;***************************************************************************
;**                                                                        *
;**  FILE        :  switch4.asm                                            *
;**                                                                        *
;**  DESCRIPTION :  Source file for __rt_switch4.                          *
;**                 Used for the binary search switch implementation.      *
;**                                                                        *
;**  Copyright 1996-2002 Altium BV                                         *
;**                                                                        *
;***************************************************************************

        .global __rt_switch4

        .sdecl  "code.librt",CODE
        .sect   "code.librt"

;;; ----------------------------------------
;;; input:
;;;     d3 - switch value
;;;     a3 - switch table address
;;; other registers used:
;;;     d0 - temp
;;;     d1 - # case labels
;;;     a2 - table mid
;;;     a6 - table begin
;;;     a7 - table end
;;; ----------------------------------------

__rt_switch4:

.include 'function_entry.asm_functional_problem_workaround'

.include 'label_after_using_Ar.asm_functional_problem_workaround'

        ld.w    d1,[a3+]        ; d1 = # case labels
        mov16.aa a6,a3          ; a6 = table begin
        addsc.a a7,a3,d1,#2     ; a7 = table end
loop:                           ; do {

.include 'label_after_using_Ar.asm_functional_problem_workaround'

        sub.a   a2,a7,a6        ; a2 = end - begin
        mov16.d d0,a2
        sh16    d0,#-3          ; d0 = (end - begin) / 2
        addsc.a a2,a6,d0,#2     ; a2 = begin + d0
        ld16.w  d0,[a2]         ; d0 = *a2
        jeq     d3,d0,found     ; match
        jge     d3,d0,skip1     ; if (d3 < d0)
        mov16.aa a7,a2          ;    a7 = a2
skip1:

.include 'label_after_using_Ar.asm_functional_problem_workaround'

        add16.a a2,#4           ; a2++
        jlt     d3,d0,skip2     ; if (d3 >= d0)
        mov16.aa a6,a2          ;    a6 = a2
skip2:

.include 'label_after_using_Ar.asm_functional_problem_workaround'

        jne.a   a6,a7,loop      ; } while ( a6 != a7 );
;
        addsc.a a2,a3,d1,#2     ; last entry is default
found:

.include 'label_after_using_Ar.asm_functional_problem_workaround'

        addsc.a a3,a2,d1,#2     ; a3 += size of case value table
        ld.a    a3,[a3]         ; a3 = target address
;
;       TC113_CPU11, TC113_CPU16 and CPU_TC048  workaround:
;
.if @DEF('_TC113_CPU11') || @DEF('_TC113_CPU16') || @DEF('_CPU_TC048') 
        nop
.endif
        ji      a3              ; jump to case or default label
